﻿using System;
using System.Linq;
using System.Diagnostics;
using System.Collections;
using Telerik.Web.UI;
using System.Data;
using System.Web.UI.WebControls;
using System.Collections.Generic;
using System.Web.Services;

public partial class Default : System.Web.UI.Page
{
    Dictionary<string, string> groupHeaderData = new Dictionary<string, string>();
    protected override void OnInit(EventArgs e)
    {
        base.OnInit(e);
        RadGrid1.NeedDataSource += (s, a) =>
        {
            (s as RadGrid).DataSource = new[] 
            {
                new { Product="AA", City="New York", Contractor="Contractor 1", PartA = 10, PartB = 20},
                new { Product="AA", City="New York", Contractor="Contractor 2", PartA = 12, PartB = 8},
                new { Product="AA", City="New York", Contractor="Contractor 3", PartA = 22, PartB = 20},
                new { Product="AA", City="Chicago", Contractor="Contractor 3", PartA = 22, PartB = 12},
                new { Product="AA", City="Chicago", Contractor="Contractor 8", PartA = 11, PartB = 33},
                new { Product="AA", City="Chicago", Contractor="Contractor 10", PartA = 24, PartB = 10},
            };
        };
        RadGrid1.ItemDataBound += new GridItemEventHandler(RadGrid1_ItemDataBound);
    }

    void RadGrid1_ItemDataBound(object sender, GridItemEventArgs e)
    {
        if (e.Item is GridGroupHeaderItem)
        {
            var groupHeaderItem = e.Item as GridGroupHeaderItem;
            if (!groupHeaderData.ContainsKey(e.Item.GroupIndex))
            {
                groupHeaderData.Add(e.Item.GroupIndex, groupHeaderItem.DataCell.Text);
            }
        }
        if (e.Item is GridGroupFooterItem)
        {
            var groupFooterItem = e.Item as GridGroupFooterItem;
            string[] headerData = groupHeaderData[groupFooterItem.GroupIndex].Split(new string[] { ": " }, StringSplitOptions.RemoveEmptyEntries);
            groupFooterItem["Product"].Text = String.Format("{1} {0} Total", headerData);
        }
    }
}